;______  ____ _  __________________  ___  _____   
;[__ ||\/||__]|  ||__/| __|___|__/|_/ ||\ || __  
;___]||  ||__]|__||  \|__]|___|  \| \_|| \||__]   
;
;
; _                                                     
;/  _  _| _   |_       | _  _ |_     _.  \    /o _  _   
;\_(_)(_|(/_  |_)\/  \_|(_)_> | ||_|(_|   \/\/ |_> (/_  
;                /                                      
; __  _      __                      _                                 
;/__ |_ \/ /(_  _    ._  _|  |_     |_) _.._  _| _ ._ _  _ ._ o    _   
;\_| |  /\/ __)(_)|_|| |(_|  |_)\/  |  (_|| |(_|(/_| | |(_)| |||_|_>   
;                               /                                      


                               
;__  ______   _  ____ ________    ___________    
;||\ ||   |   |  ||  \|___[__     |___ | |       
;|| \||___|___|__||__/|______].   |___ | |___.   
;                             '                                                                                                                           

AddMacro: MACRO
	push bc
	push af
	ld a,\1
	ld c,a
	ld b,0
	ld hl,\2
	add hl,bc
	pop af
	pop bc
endm

		INCLUDE "gbhw.inc"
        INCLUDE "hardware.inc"
        
    
        SECTION "Org $100",HOME[$100]

        nop
        jp      begin

        ;                                                             "123456789ABCDEF"
        ROM_HEADER      ROM_NOMBC, ROM_SIZE_32KBYTE, RAM_SIZE_0KBYTE,  "Cook on GBColor"

		INCLUDE "ingametiledta.inc"
		INCLUDE "ingamemap.inc"
		
        INCLUDE "memory.asm"
        
        GLOBAL TilePals
		GLOBAL pad_Read

AmountofTime		EQU 20
TimePerSecond		EQU 65


; _  _______  _   ___ ____________   
; |\/||__|||\ |   |__]|__/|  ||      
; |  ||  ||| \|   |   |  \|__||___   
;       
                           

begin:


        di

        ld      sp,$ffff
		
        call    StopLCD
        
		call	ENABLE_RAM_MBC1

        ld      a,0
        ld      [rSCX],a
        ld      [rSCY],a

        ld      hl,InGameTileData
        ld      de,$8000
        ld      bc,8*256        ; length (8 bytes per tile) x (256 tiles)
        call    mem_Copy	    ; Copy tile data to memory

		ld		a,2
		call	SWITCH_ROM_MBC1
		
		ld 		a,$01
        ld		[$FF4F],a
        
        ld      hl,DefaultMapPLN1;Draw title
        ld      de,$9800
        ld      bc,20*32
        call    mem_Copy
        
        ld 		a,$00
        ld		[$FF4F],a

        ld      hl,DefaultMapPLN0;Draw title
        ld      de,$9800
        ld      bc,20*32
        call    mem_Copy        
        
        ld		a,3
		call	SWITCH_ROM_MBC1
        
        ld      hl,TilePals
        call    SetAllCGB_BGP
        
        ld		a,1
		call	SWITCH_ROM_MBC1
        
        ld      a,LCDCF_ON|LCDCF_BG8000|LCDCF_BG9800|LCDCF_BGON|LCDCF_OBJ16|LCDCF_OBJOFF
        ld      [rLCDC],a       ; Turn screen on
		
		ld 		a,1
		ld 		[_CurHead],a
		ld		[_CurBody],a
		ld		[_CurOrder],a
		
		ld 		a,AmountofTime
		ld		[_TimeRemaining],a
		
		ld 		a,0
		ld		[_Timer],a	
		
.gameloop:
		call 	UpdateTimeRemaining
		call 	joypad
        jp      .gameloop

.you_shouldnt_be_here:
		jp begin
		ret
		
; _____  _________   ___ ________ _   _____   _   ___ ____________   
;  | ||\/||___|__/   |  \|[__ |__]|   |__| \_/    |__]|__/|  ||      
;  | ||  ||___|  \   |__/|___]|   |___|  |  |     |   |  \|__||___   
;                                                                    

UpdateTimeRemaining:

call Timer

ld a, [_TimeRemaining]

call Cnvt
call WaitVBL

ld a,b
add 14
ld [$9800 + 7 + 32],a

ld a,c
add 14
ld [$9800 + 8 + 32],a

ret


; ___ _   ____________   _  ______   _  _____ 
; |__]|   |__||   |___   |  ||__||   |  ||___ 
; |   |___|  ||___|___    \/ |  ||___|__||___ 
;                                            
; _________  __  ____________________   
; |   |  ||\ ||  ||___|__/ | |  ||__/   
; |___|__|| \| \/ |___|  \ | |__||  \   
;                                      
; by Jeff Frohwein
;
; A = Input number
; B = tens
; C = ones

Cnvt:
        ld      b,-1
        ld      d,-10
.loop:  ld      c,a
        inc     b
        add     a,d
        jr      c,.loop
        ret
        
        
; _____  _________   _  ______   ___ ________   ___ ____________   
;  | ||\/||___|__/   |__||___|   |__]|___|__/   |__]|__/|  ||      
;  | ||  ||___|  \   |  ||___|___|   |___|  \   |   |  \|__||___   
                                                                 


; Timer Function
; Updates Timer and also TimeRemaining if necessary.

Timer:
		; First order of business: Is the timer zero yet?
		; Get ready, don't destroy anything!
		push	af
		; Get the timer ready!
		ld		a, [_Timer]
		; Compare it
		cp		0
		; Skip or no skip?
		jp		nz,.skipreset
		; OK, no skip...
		; Reset the timer
		ld		a, TimePerSecond
		ld		[_Timer], a
		ld		a, [_TimeRemaining]
		cp		0
		jp 		nz,.minustr
		ld		a, AmountofTime
		ld		[_TimeRemaining], a
		jp		.endsub
.minustr:
		sub 1
		ld		[_TimeRemaining], a
		jp		.endsub
.skipreset:
		ld		a, [_Timer]
		sub 1
		ld		[_Timer], a
		jp .endsub
.endsub:
		pop af
		ret

;  ______   ____ _______    ___ ____________   
;  ||  | \_/ |__]|__||  \   |__]|__/|  ||      
; _||__|  |  |   |  ||__/   |   |  \|__||___   
;                                             
                                             
joypad:
		call pad_Read
		bit 0,a
		jp nz,.a
		bit 1,a
		jp nz,.b
		bit 2,a
		jp nz,.start
		bit 3,a
		jp nz,.select
		bit 4,a
		jp nz,.right
		bit 5,a
		jp nz,.left
		bit 6,a
		jp nz,.up
		bit 7,a
		jp nz,.down
		ret
.a:
		ld a,1
		call SWITCH_ROM_MBC1
		call ChangeHead
		ret
.b:
		ld a,1
		call SWITCH_ROM_MBC1
		call ChangeBody
		ret
.select:
		ret
.start:
		ld a,1
		call SWITCH_ROM_MBC1
		call ChangeOrder
		ret
.left:
		ld a,[rSCX]
		add 1
		ld [rSCX],a
		ret
.right:
		ld a,[rSCX]
		sub 1
		ld [rSCX],a
		ret
.up:
		ld a,[rSCY]
		add 1
		ld [rSCY],a
		ret
.down:
		ld a,[rSCY]
		sub 1
		ld [rSCY],a
		ret

; _ _ _________   ____________   _  ____ _      ___ ____________   
; | | ||__|| |    |___|  ||__/   |  ||__]|      |__]|__/|  ||      
; |_|_||  || |    |   |__||  \    \/ |__]|___   |   |  \|__||___   
;                                                                 
		
WaitVBL:
        ld      a,[rLY]
        cp      0               ; Is display on scan line 145 yet?
        jr      nz,WaitVBL      ; no, keep waiting
        ret

; _____________________  _   ____________   ___ ____________   
; [__ |   |__/|___|___|\ |   |  ||___|___   |__]|__/|  ||      
; ___]|___|  \|___|___| \|   |__||   |      |   |  \|__||___   
;                                                              

StopLCD:
        ld      a,[rLCDC]
        rlca                    ; Put the high bit of LCDC into the Carry flag
        ret     nc              ; Screen is off already. Exit.

; Loop until we are in VBlank

.wait:
        ld      a,[rLY]
        cp      145             ; Is display on scan line 145 yet?
        jr      nz,.wait        ; no, keep waiting

; Turn off the LCD

        ld      a,[rLCDC]
        res     7,a             ; Reset bit 7 of LCDC
        ld      [rLCDC],a

        ret


;____ ____ _  _   / ____ ____ _  _    ___  ____ ____ ____ ____ 
;|__/ |__| |\/|  /  |__/ |  | |\/|    |__] |__/ |  | |    [__  
;|  \ |  | |  | /   |  \ |__| |  |    |    |  \ |__| |___ ___] 
;                                                              

        
SWITCH_ROM_MBC1:
  ld [$2000],a
  ret

SWITCH_RAM_MBC1:
  ld [$4000],a
  ret

ENABLE_RAM_MBC1:
  push af
  ld a,$0A
  ld [$0000],a
  pop af
  ret
  
DISABLE_RAM_MBC1:
  push af
  ld a,$00
  ld [$0000],a
  pop af
  ret

; _  _________________ _   ________   
; |  ||__||__/||__||__]|   |___[__    
;  \/ |  ||  \||  ||__]|___|______]   
                                    

SECTION "InternalVars",BSS
_Timer:: 			DS 1		;holds time until next second
_TimeRemaining:: 	DS 1		;starts out $14 (20 decimal), holds time remaining
_CurHead::			DS 1		;which customer's head is on?
_CurBody::			DS 1		;which shirt is on?
_CurOrder::			DS 1		;what did the customer order?
_CurLevel::			DS 1		;what level are we playing?
_CurCustomer::		DS 1		;who's the current customer?
AmountOfBodies		EQU 4
AmountOfHeads		EQU 4

SECTION "WhichTiles",CODE[$4000],BANK[1]

BodyTiles:
	DB 25, 55, 57, 59
	
HeadTiles:
	DB 26, 56, 58, 60
	
OrderTiles:
	DB 41, 42, 43, 44, 45, 46

	DB "  Hello, Fello GB/Z80 Hacker!  SimBurgerKing is (C)2000 JoshuaWise.COM Enterprises. Don't ask. Built for the Bung Competition."

ChangeBody:
;		; body is at [$9800 + 34 + 32]
		ld 			a,[_CurBody]
		add			1
		cp 			4
		jp 			z,.ResBody
		jp .updatebody
.ResBody:
		ld			a,0
.updatebody:
		ld			[_CurBody],a
		AddMacro 	[_CurBody],BodyTiles
		push af
		call		WaitVBL
		lcd_WaitVRAM
		pop af
		ld a,[hl]
		ld			[$9800 + 34 + 32], a
		ret
		
ChangeOrder:
;		; body is at [$9800 + 34 + 32]
		ld 			a,[_CurOrder]
		add			1
		cp 			4
		jp 			z,.ResOrder
		jp .updateorder
.ResOrder:
		ld			a,0
.updateorder:
		ld			[_CurOrder],a
		AddMacro 	[_CurOrder],OrderTiles
		push af
		call		WaitVBL
		lcd_WaitVRAM
		pop af
		ld a,[hl]
		ld			[$9800 + 34 + 32], a
		ret

ChangeHead:
;		; Head is at [$9800 + 34 + 32]
		ld 			a,[_CurHead]
		add			1
		cp 			4
		jp 			z,.ResHead
		jp .updateHead
.ResHead:
		ld			a,0
.updateHead:
		ld			[_CurHead],a
		AddMacro 	[_CurHead],HeadTiles
		push af
		call		WaitVBL
		lcd_WaitVRAM
		pop af
		ld a,[hl]
		ld			[$9800 + 34], a
		ret
	
; ___ _  _____   ___ _____   ______________   ___ ________________   
; |__]|_/ | __   |__]|__||   |___ |  | |___   |__]|__/|  ||   [__    
; |__]| \_|__]   |   |  ||___|___ |  | |___   |   |  \|__||______]   
; 

SECTION "Palette Functions",CODE[$4000],BANK[3]
                                                                   
SetSingleCGB_BGP:
        add     a,a             ; a = pal # * 2
        add     a,a             ; a = pal # * 4
        add     a,a             ; a = pal # * 8
        add     a,$80
        ld      [$FF68],a

        ld      bc,$0869        ; b = 8, c = rBCPD
.loop1:
        di
.loop2:
        ld      a,[rSTAT]
        and     2
        jr      nz,.loop2

        ld      a,[hl+]
        ld      [c],a
        ei

        dec     b
        jr      nz,.loop1

        ret

; *** Set all background palettes ***
; Entry: HL = pntr to data for 8 palettes

SetAllCGB_BGP:
        ld      a,$80
        ld      [$FF68],a

        ld      bc,$4069        ; b = 64, c = rBCPD
.loop1:
        di
.loop2:
        ld      a,[rSTAT]
        and     2
        jr      nz,.loop2

        ld      a,[hl+]
        ld      [c],a
        ei

        dec     b
        jr      nz,.loop1

        ret

; *** Set a single object (sprite) palette ***
; Entry: HL = pntr to data for 1 palette
;         A = palette number (0-7)

SetSingleCGB_OBJP:
        add     a,a             ; a = pal # * 2
        add     a,a             ; a = pal # * 4
        add     a,a             ; a = pal # * 8
        add     a,$80
        ld      [$FF6A],a

        ld      bc,$086b        ; b = 8, c = rOCPD
.loop1:
        di
.loop2:
        ld      a,[rSTAT]
        and     2
        jr      nz,.loop2

        ld      a,[hl+]
        ld      [c],a
        ei

        dec     b
        jr      nz,.loop1

        ret

; *** Set all object (sprite) palettes ***
; Entry: HL = pntr to data for 8 palettes

SetAllCGB_OBJP:

        ld      a,$80
        ld      [$FF6A],a

        ld      bc,$406b        ; b = 64, c = rOCPD
.loop1:
        di
.loop2:
        ld      a,[rSTAT]
        and     2
        jr      nz,.loop2

        ld      a,[hl+]
        ld      [c],a
        ei

        dec     b
        jr      nz,.loop1

        ret

;  This RGBSet Macro uses RGB values from 0 to 255.
; Even though this is a greater color range than the
; GBC supports it allows you to directly read color
; values from your favorite paint program using the
; eye dropper tool and drop them directly into your
; program.


RGBSet: MACRO
        DW      ((\3 >> 3) << 10) + ((\2 >> 3) << 5) + (\1 >> 3)
        ENDM
        
;Old Data
;		cp			0
;		jr			z,.Body0
;		cp			1
;		jr			z,.Body1
;		cp			2
;		jr			z,.Body2
;		cp			3
;		jr			z,.Body3
;.Body0:
;		ld			a,[BodyTiles + 0]
;		jp			.loaditin
;.Body1:
;		ld			a,[BodyTiles + 1]
;		jp			.loaditin
;.Body2:
;		ld			a,[BodyTiles + 2]
;		jp			.loaditin
;.Body3:
;		ld			a,[BodyTiles + 3]
;		jp			.loaditin
;.loaditin: